import type { NextConfig } from "next";
import { type NextjsObfuscatorOptions } from "./type";
type PluginOptions = {
    enabled: boolean | "detect";
    /**
     * determines which files to be obfuscated
     */
    patterns: string[];
    /**
     * Additional files to be obfuscated
     */
    obfuscateFiles: Partial<{
        buildManifest: boolean;
        ssgManifest: boolean;
        webpack: boolean;
        additionalModules: string[];
    }>;
    /**
     * indicates whether the plugin logs to console
     */
    log: boolean;
};
type ObjectWithUnconstantString<T extends Record<any, any>> = {
    [key in keyof T]: Required<T>[key] extends string ? string : Required<T>[key] extends number ? number : Required<T>[key] extends string[] ? string[] : Required<T>[key] extends number[] ? number[] : Required<T>[key] extends Record<any, any> ? Partial<ObjectWithUnconstantString<T[key]>> : T[key];
};
declare function main(obfuscatorOptions: NextjsObfuscatorOptions | Partial<ObjectWithUnconstantString<NextjsObfuscatorOptions>>, pluginOptions?: Partial<PluginOptions>): (nextConfig: NextConfig) => NextConfig;
export = main;
